<template>
  <div class="main-contain">
    <div class="position">
      <bread-crumb
        v-if="this.$route.query.type == 1"
        :crumbs="crumbs"
      ></bread-crumb>
      <bread-crumb
        v-if="this.$route.query.type == 2"
        :crumbs="crumbs2"
      ></bread-crumb>

      <div style="float:right;">
        <el-button size="small" @click="back()" class="filter-item"
          >取 消</el-button
        >
        <el-button
          size="small"
          type="primary"
          @click="submit()"
          class="filter-item"
          >保 存</el-button
        >
      </div>
    </div>

    <div class="app-container">

      <drugs-stock-dialog
        ref="dialog"
        :propForm="propForm"
        :visibility="isVisibility"
        v-on:dialog-comfirm="comfirm"
        v-on:dialog-cancle="cancle"
      >

      </drugs-stock-dialog>

      <div class="filter-container">
        <div class="cell clearfix">
          <label class="title"><span class="name">退库时间</span> : </label>

          <el-date-picker
            size="small"
            v-model="return_time"
            prefix-icon="el-icon-date"
            :editable="false"
            style="width: 196px;"
            type="date"
            placeholder="选择日期时间"
            align="right"
            format="yyyy-MM-dd"
            value-format="yyyy-MM-dd"
          ></el-date-picker>
        </div>

        <!-- <div class="cell clearfix">
          <label class="title"><span class="name">经销商</span> : </label>
          <el-select
            size="small"
            v-model="form.dealer"
            filterable
            placeholder="请选择经销商"
            @change="changeDealer"
          >
            <el-option
              v-for="(option, index) in dealer"
              :key="index"
              :label="option.dealer_name"
              :value="option.id"
            >
            </el-option>
          </el-select>
        </div> -->

        <!-- <div class="cell clearfix">
          <label class="title"><span class="name">厂商</span> : </label>
          <el-select
            size="small"
            v-model="form.manufacturer"
            filterable
            placeholder="请选择厂商"
            @change="changeManufacturer"
          >
            <el-option
              v-for="(option, index) in manufacturer"
              :key="index"
              :label="option.manufacturer_name"
              :value="option.id"
            >
            </el-option>
          </el-select>
        </div> -->
      </div>

      <el-form :rules="tableRules" :model="recordInfo" ref="tableForm">
        <el-table
          :data="recordInfo.recordData"
          :class="signAndWeighBoxPatients"
          style="width: 100%"
          border
          max-height="450"
          :header-cell-style="{ backgroundColor: 'rgb(245, 247, 250)' }"
        >
          <el-table-column align="center" width="200" fixed="left">
            <template slot="header" slot-scope="scope">
              <span>药品名称<span style="color: red">*</span></span>
            </template>

            <template slot-scope="scope">
              <el-form-item style="padding-top: 20px">
                  <el-autocomplete
                    class="checkSearch"
                    popper-class="my-autocomplete"
                    v-model="scope.row.drug_name"
                    :fetch-suggestions="querySearchAsync"
                    :trigger-on-focus="true"
                    placeholder="请输入药品名称"
                    @select="handleSelect"
                    @input="changeDrugName(scope.$index)"
                    style="width:160px;"
                  >
                    <i class="el-icon-search el-input__icon" slot="suffix"></i>
                  <template slot-scope="{ item }">
                    <div class="name">{{ item.drug_name + item.dose + item.dose_unit + "*" +item.min_number + item.min_unit +"/" + item.max_unit + "  "+item.manufacturer}}</div>
                  </template>
                 </el-autocomplete>
              </el-form-item>
            </template>
          </el-table-column>
          <el-table-column align="center" width="140">
            <template slot="header" slot-scope="scope">
              <span>规格&单位</span>
            </template>
            <template slot-scope="scope">
              <el-form-item style="padding-top: 20px">
                <el-input
                  :disabled="true"
                  placeholder="请输入规格&单位"
                  v-model="scope.row.name"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>

          <el-table-column width="200" align="center">
            <template slot="header" slot-scope="scope">
              <span>退库数量<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.return_count'"
                :rules="tableRules.return_count"
                style="padding-top: 17px"
              >
              <div style="display:flex;">
                <el-input
                   oninput="value=value.replace(/\D|^0/g,'')"
                  style="width:100px"
                  placeholder="请输入退库数量"
                  type="number"
                  v-model="scope.row.return_count"
                ></el-input>
                 <el-select v-model="scope.row.max_unit" filterable placeholder="请选择单位" style="width:80px">
                    <el-option
                      v-for="(option, index) in unitList"
                      :key="index"
                      :label="option.name"
                      :value="option.name">
                    </el-option>
                  </el-select>
                </div>
              </el-form-item>
            </template>
          </el-table-column>

         <el-table-column align="center" width="150">
            <template slot="header" slot-scope="scope">
              <span>退库单价<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.price'"
                :rules="tableRules.price"
                style="padding-top: 17px"
              >
                <el-input
                  placeholder="请输入单价"
                  type="number"
                  v-model="scope.row.price"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>

          <el-table-column label="总价" align="center" width="150">
            <template slot-scope="scope">
              {{ calculate(scope.row.price * scope.row.return_count) }}
            </template>
          </el-table-column>

          <el-table-column width="200" align="center">
            <template slot="header" slot-scope="scope">
              <span>批次<span style="color: red"></span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.return_count'"
                style="padding-top: 17px"
              >
               <el-select v-model="scope.row.batch_number" filterable placeholder="请选择">
                  <el-option
                    v-for="(item,index) in numberList"
                    :key="index"
                    :label="item.batch_number"
                    :value="item.id">
                  </el-option>
              </el-select>
              </el-form-item>
            </template>
          </el-table-column>

           <el-table-column width="200" align="center">
            <template slot="header" slot-scope="scope">
              <span>品名/注册证号(备案凭证号)<span style="color: red"></span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.register_account'"
                style="padding-top: 17px"
              >
              <el-input v-model="scope.row.register_account"></el-input>
              </el-form-item>
            </template>
          </el-table-column>
           <el-table-column label="生产厂家" width="160" align="center">
            <template slot-scope="scope">
               <el-select v-model="scope.row.manufacturer" filterable placeholder="请选择厂商">
                <el-option
                  v-for="(option, index) in manufacturerList"
                  :key="index"
                  :label="option.manufacturer_name"
                  :value="option.manufacturer_name">
                </el-option>
               </el-select>
            </template>
          </el-table-column>
 

          <el-table-column label="生产日期" width="180" align="center">
            <template slot-scope="scope">
              <el-date-picker
                prefix-icon="el-icon-date"
                style="width: 145px"
                v-model="scope.row.product_date"
                type="date"
                placeholder="选择日期时间"
                format="yyyy-MM-dd"
                value-format="yyyy-MM-dd"
              ></el-date-picker>
            </template>
          </el-table-column>
          <el-table-column label="有效日期" width="180" align="center">
            <template slot-scope="scope">
              <el-date-picker
                prefix-icon="el-icon-date"
                style="width: 145px"
                v-model="scope.row.expiry_date"
                type="date"
                placeholder="选择日期时间"
                format="yyyy-MM-dd"
                value-format="yyyy-MM-dd"
              ></el-date-picker>
            </template>
          </el-table-column>


        <el-table-column label="经销商" width="160" align="center">
            <template slot-scope="scope">
                <el-select v-model="scope.row.dealer" filterable placeholder="请选择厂商">
                <el-option
                  v-for="(option, index) in dealerList"
                  :key="index"
                  :label="option.dealer_name"
                  :value="option.dealer_name">
                </el-option>
                </el-select>
            </template>
          </el-table-column>
          <el-table-column width="200" align="center">
            <template slot="header" slot-scope="scope">
              <span>退库原因<span style="color: red"></span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.remark'"
                style="padding-top: 17px"
              >
              <el-input v-model="scope.row.remark"></el-input>
              </el-form-item>
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center" width="200" fixed="right">
            <template slot-scope="scope">
              <el-tooltip
                class="item"
                effect="dark"
                content="新增"
                placement="top"
              >
                <el-button
                  size="mini"
                  type="primary"
                  icon="el-icon-circle-plus-outline"
                  @click="handleEdit(scope.$index, scope.row)"
                >
                </el-button>
              </el-tooltip>
              <el-tooltip
                class="item"
                effect="dark"
                content="删除"
                placement="top"
              >
                <el-button
                  size="mini"
                  type="danger"
                  icon="el-icon-delete"
                  @click="handleDelete(scope.$index, scope.row)"
                >
                </el-button>
              </el-tooltip>
            </template>
          </el-table-column>
        </el-table>
      </el-form>
    </div>
  </div>
</template>

<script>
import { uParseTime } from "@/utils/tools";
import {  postDrugCancelStock,GetAllConfig,GetAllDrugInfoByID,getDrugBatchNumber } from "@/api/drug/drug_stock";
import BreadCrumb from "../../components/bread-crumb";
import DrugsStockDialog from './drugsStockDialog/index'
import {postSearchDrugList } from "@/api/data"
import { getDataConfig } from "@/utils/data";
export default {
  components: { DrugsStockDialog, BreadCrumb },
  name: "salesReturnOrderAdd",

  data() {
    return {
      crumbs: [
        { path: false, name: "库存管理" },
        { path: false, name: "耗材退库单" },
        { path: false, name: "新增退库单" }
      ],
      crumbs2: [
        { path: false, name: "库存管理" },
        { path: false, name: "其他退库单" },
        { path: false, name: "新增退库单" }
      ],

      type: this.$route.query.type,
      signAndWeighBoxPatients: "sign-and-weigh-box-patients",
      return_time: "",
      currentIndex: 0,
      recordInfo: {
        recordData: []
      },
      tableRules: {
        return_count: [
          { required: true, message: "数量不能为空", trigger: "blur" }
        ]
      },
      ruleForm: {
        manufacturer: [
          { required: true, message: "请选择厂商", trigger: "change" }
        ]
      },
      // prop
      isVisibility: false,
      propForm: {
        goods: [],
        goodType: [],
        goodInfo: [],
        goodUnit: [],
        manufacturer: 0,
        dealer: 0
      },
      form: {
        manufacturer: 0,
        dealer: 0
      },
      warehouseOutInfoList: [],
      manufacturer: [],
      dealer: [],
      goodType: [],
      goodInfo:[],
      dealerList:[],
      manufacturerList:[],
      numberList:[],
      unitList:[]
    };
  },
  methods: {
    comfirm: function(val) {
     
      this.propForm.goodType = []
      this.propForm.goods = []

      this.$refs.dialog.hide()
      if (val.selectedGoodInfo.length > 0) {
        for (let i = val.selectedGoodInfo.length - 1; i >= 0; i--) {
          if (i == 0) {
            this.recordInfo.recordData[this.currentIndex].drug_id = val.selectedGoodInfo[i].id
            this.recordInfo.recordData[this.currentIndex].price = val.selectedGoodInfo[i].last_price.toString();
            this.recordInfo.recordData[this.currentIndex].retail_price = val.selectedGoodInfo[i].retail_price.toString();
          } else {
            const tempForm = {}
            tempForm['drug_id'] = val.selectedGoodInfo[i].id
            tempForm["return_count"] = "";
            tempForm["price"] = val.selectedGoodInfo[i].last_price.toString();
            tempForm["retail_price"] =  val.selectedGoodInfo[i].retail_price.toString();
            this.recordInfo.recordData.splice(this.currentIndex + 1, 0, tempForm)
          }
        }
      }
      this.currentIndex = -1
    },

    cancle: function() {
      this.$refs.dialog.hide();
    },
    GetConfigInfo: function() {
      const loading = this.$loading({
        lock: true,
        text: 'Loading',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })

      GetAllConfig().then(response => {
        if (response.data.state == 0) {
          this.$message.error(response.data.msg)
          return false
        } else {
          this.manufacturer = response.data.data.manufacturer;
          this.dealer = response.data.data.dealer;
          for(let i = 0; i<  response.data.data.drugs.length;i++){
            this.goodType.push(response.data.data.drugs[i])
            if(response.data.data.drugs[i].drug_specs != null) {
              for (let b = 0; b < response.data.data.drugs[i].drug_specs.length; b++) {
                this.goodInfo.push(response.data.data.drugs[i].drug_specs[b])
              }
            }
          }
          this.manufacturer.splice(0, 0, { id: 0, manufacturer_name: "全部" });
          this.dealer.splice(0, 0, { id: 0, dealer_name: "全部" });

          this.form.manufacturer = 0
          this.form.dealer = 0
        }
        loading.close()
      })

    },

    typeName: function(drug_id) {
      let name = "";
      for (let i = 0; i < this.goodInfo.length; i++) {
        if (this.goodInfo[i].id == drug_id) {
          name = this.goodInfo[i].drug_name;

        }
      }
      return name;
    },
    specificationName: function(drug_id) {
      let name = "";
      for (let i = 0; i < this.goodInfo.length; i++) {
        if (this.goodInfo[i].id == drug_id) {
          name = this.goodInfo[i].drug_spec;
        }
      }
      return name;
    },
    handleEdit: function(index, row) {
      const tempObj = {};
      tempObj["drug_id"] = 0;
      tempObj["return_count"] = "";
      tempObj["price"] = "";
      tempObj["retail_price"] = "";
      tempObj["register_account"] = ""
      tempObj["dealer"] = ""
      tempObj["manufacturer"] =""
      tempObj["remark"] = ""
      tempObj["product_date"] = ""
      tempObj["expiry_date"] = ""
      tempObj["batch_number"] = ""
      tempObj["max_unit"] = ""
      tempObj["batch_number_id"] = 0
      this.recordInfo.recordData.push(tempObj);
    },
    handleDelete: function(index, row) {
      if (this.recordInfo.recordData.length <= 1) {
        this.$message.error("只有一条记录的时候无法删除");
        return;
      } else {
        this.recordInfo.recordData.splice(index, 1);
      }
    },
    calculate: function(val) {
      if (val == 0) {
        return "";
      }

      return Math.round(parseFloat(val) * 100) / 100;
    },
    getTime(val, temp) {
      if (val != 0) {
        return uParseTime(val, temp);
      } else {
        return "";
      }
    },
    showDialog(index, row) {
      const loading = this.$loading({
        lock: true,
        text: 'Loading',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })
      this.currentIndex = index
      this.isVisibility = true
      const params = {
        manufacturer_id: this.form.manufacturer,
        dealer_id: this.form.dealer
      }
      GetAllDrugInfoByID(params).then(response => {
          if (response.data.state == 0) {
            this.$message.error(response.data.msg)
            return false
            loading.close()

          } else {
            loading.close()

            if (response.data.data.drugs.length <= 0) {
              this.$message.error('该厂商或经销商没有药品信息')
              return
            }
            this.$refs.dialog.show()
            for (let i = 0; i < response.data.data.drugs.length; i++) {
              this.propForm.goods.push(
                response.data.data.drugs[i]
              );
            }
            const obj = {};
            this.propForm.goods = this.propForm.goods.reduce(
              (cur, next) => {
                obj[next.id] ? "" : (obj[next.id] = true && cur.push(next));
                return cur;
              },
              []
            ); // 设置cur默认类型为数组，并且初始值为空的数组
          }

        for (let i = 0; i < this.propForm.goods.length; i++) {
          for (let a = 0; a < this.propForm.goods[i].drug_specs.length; a++) {
            var respObj = this.propForm.goods[i].drug_specs[a];
            respObj["isSelected"] = false;
          }
        }
        }
      )
    },

    back() {
      this.$router.go(-1);
    },
    submit() {
      this.$refs["tableForm"].validate(valid => {
        if (valid) {
          const array = this.recordInfo.recordData;
          let total = 0;
          for (let i = 0; i < array.length; i++) {

            if (array[i].drug_id == 0) {
              this.$message.error("药品名称或者药品规格名称不能为空");
              return;
            }
            total = total + array[i].price * array[i].return_count;
          }

          if (this.recordInfo.recordData.length <= 0) {
            this.$message.success("请添加退库商品");
            return;
          }
          for(let i=0;i<this.recordInfo.recordData.length;i++){
            this.recordInfo.recordData[i].price = this.recordInfo.recordData[i].price.toString()
             for(let j=0;j<this.numberList.length;j++){
                if(this.recordInfo.recordData[i].batch_number == this.numberList[j].id){
                   this.recordInfo.recordData[i].batch_number = this.numberList[j].batch_number
                   this.recordInfo.recordData[i].batch_number_id = this.numberList[j].id
                 
                }
             }
          }
          const params = {
            cancelStock: this.recordInfo.recordData
          };
          console.log("params2222",params,this.return_time)
        
          postDrugCancelStock(
            params,
            this.return_time,
            this.form.manufacturer,
            this.form.dealer,
            this.type
          ).then(response => {
            if (response.data.state == 0) {
              this.$message.error(response.data.msg);
              return false;
            } else {
              if(response.data.data.msg == 1){
                this.$notify({
                  title: "成功",
                  message: "退库成功",
                  type: "success",
                  duration: 2000
                });
                this.recordInfo.recordData = [];
                this.$router.back(-1);
              }
              if(response.data.data.msg == 2){
                this.$message.error("退库数量大于出库数量")
              }
            }
          });
        } else {
          return false;
        }
      });
    },
    changeManufacturer(val) {
      this.propForm.manufacturer = val;
    },
    changeDealer(val) {
      this.propForm.dealer = val;
    },
    querySearchAsync(keyword, cb) {
        let key = '';
        if (keyword != undefined) {
          key = keyword
        }
        let searchArray = [];
        postSearchDrugList(key).then(response => {
          if (response.data.state == 1) {
            searchArray = response.data.data.list;
            
             var list = response.data.data.list
             console.log("猎豹22222222222",list)

             this.drugList = list
             var manufacturerList = response.data.data.manufacturerList
             this.manufacturerList = manufacturerList
             var dealerList = response.data.data.dealerList
             this.dealerList = dealerList
             for(let i=0;i<this.drugList.length;i++){
             
                for(let j=0;j<this.manufacturerList.length;j++){
                  if(this.drugList[i].manufacturer == this.manufacturerList[j].id){
                     this.drugList[i].manufacturer = this.manufacturerList[j].manufacturer_name
                  }
                }
               

                for(let z=0;z<dealerList.length;z++){
                  if(this.drugList[i].dealer == this.dealerList[z].id){
                      this.drugList[i].dealer = this.dealerList[z].dealer_name
                  }
               
                }
             }
             cb(this.drugList)
          } else {
            cb([])
          }
        })
      },
      changeDrugName(val){
        this.currentIndex = val
      },
      handleSelect(val){
         console.log("val23232",val)
         this.getDrugBatchNumber(val.id)
         for(let i=0;i<this.recordInfo.recordData.length;i++){
           if(i == this.currentIndex){
             this.recordInfo.recordData[i].drug_id  = val.id
             this.recordInfo.recordData[i].drug_name = val.drug_name
             this.recordInfo.recordData[i].drug_type = val.drug_type
             this.recordInfo.recordData[i].name  = val.dose +val.dose_unit+"*"+val.min_number+ val.min_unit+"/"+val.max_unit
             this.recordInfo.recordData[i].last_price = val.last_price
             this.recordInfo.recordData[i].price = val.last_price
             this.recordInfo.recordData[i].manufacturer =  val.manufacturer
             this.recordInfo.recordData[i].number =  val.number
             this.recordInfo.recordData[i].max_unit = val.max_unit
             this.recordInfo.recordData[i].min_unit = val.min_unit
             if(val.dealer == 0){
               this.recordInfo.recordData[i].dealer = ""
             }else{
               this.recordInfo.recordData[i].dealer = val.dealer
             }
            
           }
        }
        console.log("333333",this.recordInfo.recordData)
      },
      getDrugBatchNumber(id){
          var params = {
            id:id
          }
        getDrugBatchNumber(params).then(response=>{
           if(response.data.state == 1){
             var list = response.data.data.list
             console.log("list2222",list)
             this.numberList = list
           }
        })
      },
      getDataConfig(module, filed_name){
       return getDataConfig(module, filed_name)
      },
  },
  created() {
    var nowDate = new Date();
    var nowYear = nowDate.getFullYear();
    var nowMonth = nowDate.getMonth() + 1;
    var nowDay = nowDate.getDate();
    this.return_time =
      nowYear +
      "-" +
      (nowMonth < 10 ? "0" + nowMonth : nowMonth) +
      "-" +
      (nowDay < 10 ? "0" + nowDay : nowDay);

    const tempObj = {};
    tempObj["drug_id"] = 0;
    tempObj["return_count"] = "";
    tempObj["price"] = "";
    tempObj["retail_price"] = "";
    tempObj["register_account"] = ""
    tempObj["dealer"] = ""
    tempObj["manufacturer"] =""
    tempObj["remark"] = ""
    tempObj["product_date"] = ""
    tempObj["expiry_date"] = ""
    tempObj["batch_number"] = ""
    tempObj["batch_number_id"] = 0
    tempObj["max_unit"] = ""
    this.unitList =  getDataConfig('hemodialysis','units')
    console.log("单位",this.unitList)
    this.recordInfo.recordData.push(tempObj);
    this.GetConfigInfo();
    this.propForm.goodUnit = this.$store.getters.good_unit;
  }
};
</script>

<style rel="stylesheet/css" lang="scss" scoped>
.information {
  border: 1px #dcdfe6 solid;
  padding: 30px 20px 30px 20px;

  .border {
    border-bottom: 1px #dcdfe6 solid;
    margin: 0px 0 20px 0;
  }
}

.edit_separater {
  border-top: 1px solid rgb(233, 233, 233);
  margin-top: 15px;
  margin-bottom: 15px;
}
</style>

<style>
.sign-and-weigh-box .sign-and-weigh-box-patients .cell {
  font-size: 12px;
}

.sign-and-weigh-box .sign-and-weigh-box-patients .current-row > td {
  background: #6fb5fa;
}
</style>
